﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class GameManagerScript : MonoBehaviour
{
    public delegate void GameDelegate(AnimatorOverrideController comBola, AnimatorOverrideController semBola);
    public static GameDelegate turnManager;

    private float currentTime;

    [SerializeField] GameObject playerPrefab;
    [SerializeField] GameObject npcPrefab;
    [SerializeField] Transform playerInitialPosition;
    [SerializeField] Transform npcInitialPosition;
    [SerializeField] private float turnDuration;
    [SerializeField] private AnimatorOverrideController comBolaStateMachine;
    [SerializeField] private AnimatorOverrideController semBolaStateMachine;

    private GameObject player;
    private GameObject npc;

    // Use this for initialization
    void Start ()
    {
        currentTime = turnDuration;
        setupGame();
        turnManager(comBolaStateMachine, semBolaStateMachine);
        BallControllerOld.ballStatus = endTurn;
    }
	
	// Update is called once per frame
	void Update ()
    {
        if (currentTime <= 0)
        {
            turnManager(comBolaStateMachine, semBolaStateMachine);
            player.transform.position = playerInitialPosition.position;
            npc.transform.position = npcInitialPosition.position;
            currentTime = turnDuration;
        }
        else
        {
            currentTime -= Time.deltaTime;
        }
	}

    private void setupGame()
    {
        player = Instantiate(playerPrefab, playerInitialPosition.position, playerInitialPosition.rotation) as GameObject;
        npc = Instantiate(npcPrefab, npcInitialPosition.position, npcInitialPosition.rotation) as GameObject;

        player.GetComponent<PlayerControllerOld>().setup();
        npc.GetComponent<NpcController>().setup();
    }

    private void endTurn(string ballState)
    {
        if (ballState == "Fora da quadra" || ballState == "No chao")
        {
            sleepPlayers();
            //resetTimer();
            startTurn();
        }
    }

    private void sleepPlayers()
    {
        player.SetActive(false);
        npc.SetActive(false);
    }
    
    private void resetTimer()
    {
        currentTime = 0;
    }

    private void startTurn()
    {
        player.SetActive(true);
        npc.SetActive(true);
    }
}
