﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MovementScriptOld : MonoBehaviour
{
    public delegate void NotifyIA(Vector2 position);
    public static NotifyIA notify;

    private Animator stateMachine;
    private Rigidbody2D rb;
    private string horizontalAxis;
    private string verticalAxis;
    private bool isMoving;

    [SerializeField] private float timeEffect;
    [SerializeField] private KeyCode frente;
    [SerializeField] private KeyCode tras;
    [SerializeField] private KeyCode cima;
    [SerializeField] private KeyCode baixo;

    // Use this for initialization
    void Start ()
    {
        OnEnable();

        rb = GetComponent<Rigidbody2D>();
        isMoving = false;
	}
	
	// Update is called once per frame
	void Update ()
    {
        if (Input.GetKeyDown(frente) && !isMoving)
        {
            stateMachine.Play("Movimento");
            rb.MovePosition(rb.position + Vector2.right);
            StartCoroutine(notifyIA(Vector2.right));
        }
        if (Input.GetKeyDown(tras) && !isMoving)
        {
            stateMachine.Play("Movimento");
            rb.MovePosition(rb.position + Vector2.left);
            StartCoroutine(notifyIA(Vector2.left));
        }
        if (Input.GetKeyDown(cima) && !isMoving)
        {
            stateMachine.Play("Movimento");
            rb.MovePosition(rb.position + Vector2.up);
            StartCoroutine(notifyIA(Vector2.up));
        }
        if (Input.GetKeyDown(baixo) && !isMoving)
        {
            stateMachine.Play("Movimento");
            rb.MovePosition(rb.position + Vector2.down);
            StartCoroutine(notifyIA(Vector2.down));
        }
    }

    private void moving()
    {
        isMoving = true;
    }

    private void notMoving()
    {
        isMoving = false;
    }

    private IEnumerator notifyIA(Vector2 position)
    {
        if (notify != null)
        {
            yield return new WaitForSeconds(timeEffect);
            notify(position);
        }
    }

    public void setStateMachine(Animator animator)
    {
        stateMachine = animator;
    }

    public void updateStateMachine(AnimatorOverrideController animator)
    {
        stateMachine.runtimeAnimatorController = animator;
    }

    private void OnEnable()
    {
        MovingBehavior.enterMoving = moving;
        MovingBehavior.exitMoving = notMoving;
    }

    private void OnDisable()
    {
        MovingBehavior.enterMoving -= moving;
        MovingBehavior.exitMoving -= notMoving;
    }
}
