﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class NpcController : MonoBehaviour
{
    private IAAtkScript atkSkills;
    private IADefScript defSkills;
    private bool myTurn;

    // Use this for initialization
    public void setup()
    {
        GameManagerScript.turnManager += changeTurn;

        atkSkills = GetComponent<IAAtkScript>();
        defSkills = GetComponent<IADefScript>();

        atkSkills.setRigidBody(GetComponent<Rigidbody2D>());
        defSkills.setRigidBody(GetComponent<Rigidbody2D>());

        atkSkills.setStateMachine(GetComponent<Animator>());
        defSkills.setStateMachine(GetComponent<Animator>());
        myTurn = false;
    }
    
    private void changeTurn(AnimatorOverrideController comBola, AnimatorOverrideController semBola)
    {
        if (myTurn)
        {
            atkTurn(comBola);
        }
        else
        {
            defenseTurn(semBola);
        }
    }

    private void atkTurn(AnimatorOverrideController stateMachine)
    {
        Debug.Log("Npc turn");
        myTurn = false;
        atkSkills.enabled = true;
        atkSkills.startLoop();
        atkSkills.updateStateMachine(stateMachine);
        defSkills.enabled = false;
    }

    private void defenseTurn(AnimatorOverrideController stateMachine)
    {
        myTurn = true;
        atkSkills.endLoop();
        atkSkills.enabled = false;
        defSkills.enabled = true;
        defSkills.updateStateMachine(stateMachine);
    }
}
