﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class PlayerControllerOld : MonoBehaviour
{
    private MovementScriptOld movement;
    private ThrowScript shoot;
    private AtkSkillScript atkSkills;
    private DefSkillScript defSkills;
    private bool myTurn;

    public void setup()
    {
        GameManagerScript.turnManager += changeTurn;
        movement = GetComponent<MovementScriptOld>();
        shoot = GetComponent<ThrowScript>();
        atkSkills = GetComponent<AtkSkillScript>();
        defSkills = GetComponent<DefSkillScript>();
        myTurn = true;
        
        movement.setStateMachine(GetComponent<Animator>());
        shoot.setStateMachine(GetComponent<Animator>());
        atkSkills.setStateMachine(GetComponent<Animator>());
        defSkills.setStateMachine(GetComponent<Animator>());
    }
	
    private void changeTurn(AnimatorOverrideController comBola, AnimatorOverrideController semBola)
    {
        if (myTurn)
        {
            atkTurn(comBola);
        }
        else
        {
            defenseTurn(semBola);
        }
    }

    private void atkTurn(AnimatorOverrideController stateMachine)
    {
        myTurn = false;
        Debug.Log("Player turn");
        movement.enabled = true;
        shoot.enabled = true;
        atkSkills.enabled = true;
        defSkills.enabled = false;

        updateStateMachine(stateMachine);
    }

    private void defenseTurn(AnimatorOverrideController stateMachine)
    {
        myTurn = true;
        movement.enabled = true;
        defSkills.enabled = true;
        shoot.enabled = false;
        atkSkills.enabled = false;
        updateStateMachine(stateMachine);
    }

    private void updateStateMachine(AnimatorOverrideController stateMachine)
    {
        movement.updateStateMachine(stateMachine);
        shoot.updateStateMachine(stateMachine);
        atkSkills.updateStateMachine(stateMachine);
        defSkills.updateStateMachine(stateMachine);
    }
}
