﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class ThrowScript : MonoBehaviour
{
    private string throwAxis;
    private Animator stateMachine;
    private bool isShooting;

    [SerializeField] private GameObject ball;
    [SerializeField] private GameObject basket;
    [SerializeField] private Transform spawnPosition;
    [SerializeField] private float xForce;
    [SerializeField] private float minYForce;
    [SerializeField] private float maxYForce;

	// Use this for initialization
	void Start ()
    {
        isShooting = false;
        throwAxis = "Fire";
        OnEnable();
    }
	
	// Update is called once per frame
	void Update ()
    {
        if (Input.GetAxisRaw(throwAxis) > 0 && !isShooting)
        {
            stateMachine.Play("Arremesso");
        }
    }

    private void shoot()
    {
        if (isActiveAndEnabled)
        {
            Vector3 norTar = (basket.transform.position - transform.position).normalized;
            GameObject clone = Instantiate(ball, spawnPosition.position, spawnPosition.rotation) as GameObject;
            Vector2 vector = new Vector2(norTar.x * xForce, Random.Range(minYForce, maxYForce) - transform.position.y);
            clone.GetComponent<Rigidbody2D>().AddForce(vector, ForceMode2D.Impulse);
        }
    }

    public void setStateMachine(Animator animator)
    {
        stateMachine = animator;
    }

    public void updateStateMachine(AnimatorOverrideController animator)
    {
        stateMachine.runtimeAnimatorController = animator;
    }

    private void OnEnable()
    {
        ThrowingBehavior.exitThrowing = shoot;
    }

    private void OnDisable()
    {
        ThrowingBehavior.exitThrowing -= shoot;
    }
}
